namespace slk
{
   template <typename T, int n>
   struct init
   {
      init(T *);
   };

   template <typename T, int n>
   inline
   init<T,n>::init(T *t)
   {
      t[n - 1] = n;
      init<T, n - 1>::init(t);
   }

   template <typename T>
   struct init<T, 1>
   {
      init(T *t)
      {
         t[0] = 1;
      }
   };

   template <typename T, int n>
   inline
   void fill(T *t)
   {
      init<T, n> s(t);
   }

   int vector[10];
}; // namespace //   slk

///////////////////////////////////////////////
int main(int, char *[])
{
   asm
   {
      NOP
   }
   slk::fill<int, 10>(slk::vector);
   asm
   {
      NOP
   }
   return 0;
}

/*
--
 ___ __ _ _
[   ]  ] ' ] MENOS
 \   [   <   Przemysaw liwiski
[ _ ] _ ] _] menos.slk@wp.pl


It works:

   template <typename T,int n>
   struct sset
   {
      static void fill(T *);
   };

   template <typename T,int n>
   inline
   void sset<T,n>::fill(T *t)
   {
      sset<T,n-1>::fill(t);
      t[n-1] = n;
   }

   template <typename T>
   struct sset<T,1>
   {
      static void fill(T *);
   };

   template <typename T>
   inline
   void sset<T,1>::fill(T *t)
   {
      t[0] = 1;
   }


*/
