#include <iostream>

namespace slk
{
   // -- ------- --
   // -- product --
   // -- ------- --

   template <int n>
   inline
   int product();

   template <>
   inline
   int product<0>()
   {
      return 1;
   }

   template <int n>
   inline
   int product()
   {
      return n * product<n - 1>();
   }


   // -- ---- --
   // -- fill --
   // -- ---- --

   int vector[10];

   template <int n>
   inline
   void fill();

   template <int n>
   inline
   void fill()
   {
      fill<n - 1>();
      vector[n - 1] = n;
   }

   template <>
   inline
   void fill<1>()
   {
      vector[0] = 1;
   }

}; // namespace //   slk

///////////////////////////////////////////////
int main(int, char *[])
{
   asm
   {
      NOP
   }
   slk::fill<10>();
   asm
   {
      NOP
   }
   int pr = slk::product<6>();  // NRV optimalization
   asm
   {
      NOP
   }
   std::cout << pr
             << std::endl;
   return 0;
}

/*
--
 ___ __ _ _
[   ]  ] ' ] MENOS
 \   [   <   Przemysaw liwiski
[ _ ] _ ] _] menos.slk@wp.pl
*/
