#include <iostream>

template <int n>
struct fibonacci: virtual public fibonacci<n - 1>,
                  virtual public fibonacci<n - 2>
{
   typedef fibonacci<n - 1> inherited_1;
   typedef fibonacci<n - 2> inherited_2;

   static const int result = inherited_1::result
                           + inherited_2::result;
};

template <>
struct fibonacci<1>
{
   static const int result = 1;
};

template <>
struct fibonacci<0>
{
   static const int result = 0;
};

int main(int, char *const [])
{
   using std::cout;
   using std::endl;

   cout << fibonacci<10>::result << endl;
   return 0;
}
